summaryrefslogtreecommitdiffstats
path: root/scripts/postinst-intercepts
diff options
context:
space:
mode:
authorLaurentiu Palcu <laurentiu.palcu@intel.com>2013-02-12 18:12:36 +0200
committerRichard Purdie <richard.purdie@linuxfoundation.org>2013-02-13 16:52:28 +0000
commit7306dbea6d5ea95624f89bb247b742392be20046 (patch)
tree8106894b93f7c3ff332957806092db88acfab780 /scripts/postinst-intercepts
parentc77e1f4e14edf7a07000f0e7360d42039af5e524 (diff)
downloadpoky-7306dbea6d5ea95624f89bb247b742392be20046.tar.gz
poky-7306dbea6d5ea95624f89bb247b742392be20046.tar.bz2
poky-7306dbea6d5ea95624f89bb247b742392be20046.zip
Add separate directory for postinstall intercepts
The scripts/postinst-intercepts will contain all postinstall hooks that we need to run after all packages have been installed. If one wants to install such a postinst hook, all it needs to do is put the hook in this directory and, from the package postinstall scriptlet, call: postinst_intercept <hook_name> <package_name> <var1=...> ... This will, practically, add the package_name in the list of packages that need the hook to run and, also, set any variables that would be needed in the hook. For example, variables like ${libdir}, ${bindir}, etc. that might depend on distribution can be passed on to the script in this way. (From OE-Core rev: 0ef538d75c2f3921a2fcbe6ca1deed5525b276cc) Signed-off-by: Laurentiu Palcu <laurentiu.palcu@intel.com> Signed-off-by: Richard Purdie <richard.purdie@linuxfoundation.org>
Diffstat (limited to 'scripts/postinst-intercepts')
-rwxr-xr-xscripts/postinst-intercepts/postinst_intercept37
-rw-r--r--scripts/postinst-intercepts/update_font_cache7
-rw-r--r--scripts/postinst-intercepts/update_icon_cache12
-rw-r--r--scripts/postinst-intercepts/update_pixbuf_cache10
4 files changed, 66 insertions, 0 deletions
diff --git a/scripts/postinst-intercepts/postinst_intercept b/scripts/postinst-intercepts/postinst_intercept
new file mode 100755
index 0000000000..ed32f27802
--- /dev/null
+++ b/scripts/postinst-intercepts/postinst_intercept
@@ -0,0 +1,37 @@
+#!/bin/sh
+#
+# This script is called from inside postinstall scriptlets at do_rootfs time. It
+# actually adds, at the end, the list of packages for which the intercept script
+# is valid. Also, if one wants to pass any variables to the intercept script from
+# the postinstall itself, they will be added immediately after the shebang line.
+#
+# Usage: postinst_intercept <intercept_script_name> <package_name> <var1=...> ... <varN=...>
+# * intercept_script_name - the name of the intercept script we want to change;
+# * package_name - add the package_name to list of packages the intercept script
+# is used for;
+# * var1=... - var1 will have the value we provide in the intercept script. This
+# is useful when we want to pass on variables like ${libdir} to
+# the intercept script;
+#
+[ $# -lt 2 ] && exit 1
+
+intercept_script=$INTERCEPT_DIR/$1 && shift
+package_name=$1 && shift
+
+[ -f "$intercept_script" ] || exit 1
+
+chmod +x "$intercept_script"
+
+pkgs_line="$(cat $intercept_script|grep "##PKGS:")"
+if [ -n "$pkgs_line" ]; then
+ # line exists, add this package to the list only if it's not already there
+ if [ -z "$(echo "$pkgs_line" | grep " $package_name ")" ]; then
+ sed -i -e "s/##PKGS:.*/\0${package_name} /" $intercept_script
+ fi
+else
+ for var in $@; do
+ sed -i -e "\%^#\!/bin/.*sh%a $var" $intercept_script
+ done
+ echo "##PKGS: ${package_name} " >> $intercept_script
+fi
+
diff --git a/scripts/postinst-intercepts/update_font_cache b/scripts/postinst-intercepts/update_font_cache
new file mode 100644
index 0000000000..562b5b3cb9
--- /dev/null
+++ b/scripts/postinst-intercepts/update_font_cache
@@ -0,0 +1,7 @@
+#!/bin/sh
+
+PSEUDO_UNLOAD=1 qemuwrapper $D$(readelf -l $D${bindir}/fc-cache| grep "Requesting program interpreter"|sed -e 's/^.*\[.*: \(.*\)\]/\1/') \
+ --library-path $D/lib:$D/usr/lib $D${bindir}/fc-cache \
+ --sysroot=$D >/dev/null 2>&1
+
+
diff --git a/scripts/postinst-intercepts/update_icon_cache b/scripts/postinst-intercepts/update_icon_cache
new file mode 100644
index 0000000000..8e17a6ac0c
--- /dev/null
+++ b/scripts/postinst-intercepts/update_icon_cache
@@ -0,0 +1,12 @@
+#!/bin/sh
+
+set -e
+# update native pixbuf loaders
+gdk-pixbuf-query-loaders --update-cache
+
+for icondir in $D/usr/share/icons/*/ ; do
+ if [ -d $icondir ] ; then
+ gtk-update-icon-cache -fqt $icondir
+ fi
+done
+
diff --git a/scripts/postinst-intercepts/update_pixbuf_cache b/scripts/postinst-intercepts/update_pixbuf_cache
new file mode 100644
index 0000000000..64033dc48a
--- /dev/null
+++ b/scripts/postinst-intercepts/update_pixbuf_cache
@@ -0,0 +1,10 @@
+#!/bin/sh
+
+export GDK_PIXBUF_MODULEDIR=$D${libdir}/gdk-pixbuf-2.0/2.10.0/loaders
+
+PSEUDO_UNLOAD=1 qemuwrapper $D$(readelf -l $D${bindir}/gdk-pixbuf-query-loaders|grep "Requesting program interpreter"|sed -e 's/^.*\[.*: \(.*\)\]/\1/') \
+ --library-path $D/lib:$D/usr/lib $D${bindir}/gdk-pixbuf-query-loaders \
+ >$GDK_PIXBUF_MODULEDIR/../loaders.cache 2>/dev/null && \
+ sed -i -e "s:$D::g" $GDK_PIXBUF_MODULEDIR/../loaders.cache
+
+